<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PindahsubinvService;
use App\Http\Validators\PindahsubinvValidator;
/* use App\Http\Services\KapalService;
use App\Http\Services\UsersService; */
use App\Http\Services\WorkflowService;
use App\Http\Services\LokasiitemService;
use App\Http\Services\ItempindahsubinvService;
use App\Http\Services\VoyagesService;
use App\Http\Services\StokkapalService;
use App\Http\Services\ActivitylogService;
use PDF;

class PindahsubinvController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $kapal;
    private $lokasiitem;
    private $itempindahsubinv;
    private $users;
    private $workflow;
    private $voyage;
    private $stokkapal;
    private $activityLog;

    /**
     * Pindahsubinv constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PindahsubinvService();
        $this->validator = new PindahsubinvValidator();
        $this->lokasiitem = new LokasiitemService();
        $this->workflow = new WorkflowService();
        /* $this->kapal = new KapalService();
        $this->users = new UsersService(); */
        $this->itempindahsubinv = new ItempindahsubinvService();
        $this->voyage = new VoyagesService();
        $this->stokkapal = new StokkapalService();
        $this->activityLog= new ActivitylogService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $input = $request->all();
        $this->validator->beforeInsert($input);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $auth = json_decode($request->session()->get('auth'));

            $input["refId"] = $input["moNumber"] = $this->baseService->getLastestID($input["tipeTransaksi"] . date("y") . $auth->orgId);
            $ID = $this->baseService->store($input);     
            $this->itempindahsubinv->store($input);
            $this->workflow->store($input);

            $input["date"] = date("Y-m-d H:i:s");
            $input["username"] = $auth->username;
            $input["activity"] = "CREATE";
            $input["deskripsi"] = $auth->name . " just <b>created</b> new Pindah Barang Sub-Inventory <a href=\"" . url("administrator/pindahsubinv/" . $ID) . "\">" . $input["refId"] . "</a>";
            $this->activityLog->store($input);

            DB::commit();
            $this->sync();
            return redirect()->to("administrator/pindahsubinv")->with("successMessages", "Data sudah berhasil disimpan dengan No #" . $input["refId"]);
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["prNumber" => "PR Number"
            , "kapalId" => "Kapal"
            , "locationId" => "Location"
            , "approverId" => "Approver"
            , "requesterId" => "Requester"
            , "destinationType" => "Destination Type"
        ];
        $this->data["criteria"] = ["prNumber" => "PR Number"
            , "kapalId" => "Kapal"
            , "locationId" => "Location"
            , "approverId" => "Approver"
            , "requesterId" => "Requester"
            , "destinationType" => "Destination Type"
        ];
        $this->data["ordering"] = [
            "moNumber:asc" => "No Transaksi &uarr;"
            , "moNumber:desc" => "No Transaksi &darr;"            
            , "dateRequired:asc" => "Tgl Dibutuhkan &uarr;"
            , "dateRequired:desc" => "Tgl Dibutuhkan &darr;"
        ];
        $this->data["lokasiitems"] = $this->lokasiitem->index($request);
        // $this->data["voyages"] = $this->voyage->index();
        $this->data["pindahsubinvs"] = $this->baseService->paging($request);
        return view("modules.pindahsubinv.pindahsubinv_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["pindahsubinv"] = $this->baseService->show($id);

        $this->data["criteria"] = [ "id" => "ID" , "namaItem" => "Nama Item", "deskripsi" => "Deskripsi" ];
        $this->data["listItems"] = $this->itempindahsubinv->showBasedOnPindahsubinv($request, $this->data["pindahsubinv"]);
        return view("modules.pindahsubinv.pindahsubinv_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/pindahsubinv")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request)
    {
        $this->data["lokasiitems"] = $this->lokasiitem->index($request);

        $this->data["criteria"] = [            
            "deskripsi"     => "Deskripsi" ,
            "part_number"    => "Part Number",
            "namaItem"      => "Kode Item"
        ];
        // $this->data["voyages"] = $this->voyage->index();
        return view("modules.pindahsubinv.pindahsubinv_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        try{
            $this->data["pindahsubinv"] = $this->baseService->show($id);       
            if($this->data["pindahsubinv"]) {
                $this->data["listItems"] = $this->itempindahsubinv->showBasedOnPindahsubinv($request, $this->data["pindahsubinv"]);
                return view("modules.pindahsubinv.pindahsubinv_show", $this->data);
            } else {
                return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
            }
        } catch (\Exception $e) {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    
    public function approval(Request $request, $id)
    {       
        $this->data["isApproval"] = true;
        $this->data["pindahsubinv"] = $this->baseService->show($id);
        $this->data["listItems"] = $this->itempindahsubinv->showBasedOnPindahSubinv($request, $this->data["pindahsubinv"]);
        return view("modules.pindahsubinv.pindahsubinv_show", $this->data);
    }

    public function saveApproval(Request $request)
    {       
        $auth = json_decode($request->session()->get('auth'));
        $input = $request->all();
        $input["refId"] = $input["moNumber"];
        $this->validator->beforeApprove($input);
        if ($this->validator->hasError()) {
            return $this->validator->validateView();
        }

        $transaction = $this->baseService->showByTransactionNo($input["refId"]);
        if($transaction->status > 0) {
            return redirect()->back()->with("errMessage", "Status transaksi #" . $input["refId"] . " sudah tidak open lagi!");
        } else {

            DB::beginTransaction();
            try {
                $this->baseService->approve($input);
                $this->workflow->approve($input);
                $input["username"] = $auth->username;

                if($input["status"] == 1) {
                    $staging["header"] = $transaction; // $this->baseService->showByTransactionNo($input["moNumber"]);
                    $staging["footer"] = $input["items"] = $this->itempindahsubinv->showBasedOnPindahSubinv($request, $staging["header"]);

                    $stockHistory = [
                        "transaksi"     => "pindahbarangsubinv",
                        "noTransaksi"   => $input["refId"],
                        "username"      => $auth->username,
                        "periode"       => $staging["header"]->dateRequired
                    ];
                    $input["dateRequired"] =  $staging["header"]->dateRequired;
                    $data = $this->baseService->getPrepareUpdateStock($input);
                    $this->stokkapal->updateStock($data);
                    $this->stokkapal->reduceStock($input["items"], $stockHistory);
                    
                    $staging["auth"] = $auth;
                    $this->baseService->saveStaging($staging);
                }

                $input["date"] = date("Y-m-d H:i:s");            
                $input["activity"] = "APPROVAL";
                $input["namaTransaksi"] = "Workflow";
                $input["deskripsi"] = $auth->name . " just <b>approved</b> transaction Permintaan Barang <b>#" . $input["refId"] . "</b>";
                $this->activityLog->store($input);

                DB::commit();
                $this->sync();
                return redirect()->to("administrator/workflow")->with("successMessages", "Data dengan No #" . $input["refId"] . " sudah berhasil disimpan");
            } catch (\Exception $e) {
                DB::rollBack();
                throw new DefaultException($e->getMessage());
            }
        }
    }

    public function search(Request $request) {
        $data = $this->stokkapal->getStokList($request);
        echo json_encode($data); 
    }

    public function gandroomPaging(Request $request) {        
        return view("modules.gandroom.gandroom_index", $this->data);
    }

    public function gandroomPDF(Request $request, $ID) {
        PDF::SetTitle('Pindah SubInventori');
        PDF::AddPage();

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["pindahsubinv"]   = $this->baseService->show($ID);
        $data["listItems"]      = $this->itempindahsubinv->showBasedOnPindahsubinv($request, $data["pindahsubinv"]);

        $view = \View::make("modules.pindahsubinv.gandroom-pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false. "");
        PDF::Output('gandroom.pdf');
    }
    
    public function getSubInvTujuan(Request $request) {
		$data = $this->lokasiitem->getListNotIn($request);
		echo json_encode($data); 
	}
}